﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Xml;

namespace converter
{
    public partial class Form1 : Form
    {
        string firstval = "", secondval = "";
        double amount;
        Valute val1 = new Valute();
        Valute val2 = new Valute();
        List<Valute> valutes = new List<Valute>();

        XmlDocument xDoc = new XmlDocument();

        int[] parts = new int[10];
        int leftover;
        string ending;


        public Form1()
        {
            InitializeComponent();
            Load_("http://www.cbr.ru/scripts/XML_daily.asp");
        }

        private void Load_(string path)
        {
            try
            {
                xDoc.Load(path);

            }
            catch (Exception ex)
            {
                MessageBox.Show($"Чет инета нет ( потому что {ex.Message.ToString().ToLower()})", "Error");
            }

            XmlElement xRoot = xDoc.DocumentElement;

            this.Text = $"Monverter - курс за {xRoot.Attributes[0].Value}";

            foreach (XmlNode xnode in xRoot)
            {
                Valute valute = new Valute();
                valute.ID = xnode.Attributes[0].Value;
                foreach (XmlNode chlnode in xnode.ChildNodes)
                {
                    if (chlnode.Name == "CharCode")
                    {
                        valute.CharCode = chlnode.InnerText;
                    }

                    if (chlnode.Name == "Nominal")
                    {
                        valute.Nominal = Convert.ToUInt32(chlnode.InnerText);
                    }

                    if (chlnode.Name == "Name")
                    {
                        valute.Name = chlnode.InnerText;
                    }

                    if (chlnode.Name == "Value")
                    {
                        valute.Value = Convert.ToDouble(chlnode.InnerText);
                    }

                    if (chlnode.Name == "NumCode")
                    {
                        valute.NumCode = chlnode.InnerText;
                    }
                }

                valutes.Add(valute);
            }
            valutes.Add(new Valute()
            {
                CharCode = "RUR",
                Nominal = 1,
                Name = "Российский рубль",
                Value = 1,
                NumCode = "810",

                Bills = new int[] { 5000, 2000, 1000, 200, 100, 50 },
                Coins = new int[] { 10, 5, 2, 1 }
            });

            foreach (Valute valute in valutes)
            {
                comboBox1.Items.Add($"{valute.Name}");

                comboBox2.Items.Add($"{valute.Name}");
            }
        }

        private void ComboBox_Selected(object sender, EventArgs e)
        {
            ComboBox comboBox = (ComboBox)sender;
            string selectedItem = (string)comboBox.SelectedItem;
            firstval = selectedItem;

        }

        private void ComboBox_Selected_2(object sender, EventArgs e)
        {
            ComboBox comboBox = (ComboBox)sender;
            string selectedItem = (string)comboBox.SelectedItem;
            secondval = selectedItem;

        }

        private void button2_Click(object sender, EventArgs e)
        {

            Load_($"http://www.cbr.ru/scripts/XML_daily.asp?date_req={dateTimePicker1.Value.ToShortDateString().Replace('.', '/')}");

        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void Translate(object sender, EventArgs e)
        {
            val1 = valutes.FirstOrDefault(x => x.Name == firstval);
            val2 = valutes.FirstOrDefault(x => x.Name == secondval);
            if (val2 == null || val1 == null)
            {
                MessageBox.Show("Пожалуйста, выберете валюты");
            }
            else
            {
                try
                {
                    amount = Convert.ToDouble(firstValue.Text);
                    double amount2 = val1.Value / val1.Nominal;
                    double amount3 = val2.Value / val2.Nominal;
                    double final_value = amount * (amount2 / amount3);
                    secondValue.Text = final_value.ToString();

                    if (checkBox1.Checked)
                        Change(val1.Bills, val1.Coins);
                }
                catch (Exception ex)
                {
                    MessageBox.Show($"{ex.Message.ToString()}", "Error");
                }
            }
        }
        private void Change(int[] bills, int[]coins)
        {
            if (bills == null || coins == null)
                MessageBox.Show("Для данной валюты ещё не назначены деньги");
            else
            {
                parts[0] = Convert.ToInt32(amount) / bills[0];
                leftover = Convert.ToInt32(amount) - parts[0] * bills[0];
                if (parts[0] == 1)
                    ending = "а";
                else if (parts[0] > 1 && parts[0] < 5)
                    ending = "ы";
                else
                    ending = "";
                label1.Text = $"{parts[0]} купюр{ending} по {bills[0]}";

                for (int i = 1; i < 6; i++)
                {
                    parts[i] = leftover / bills[i];

                    if (parts[i] == 1)
                        ending = "а";
                    else if (parts[i] > 1 && parts[i] < 5)
                        ending = "ы";
                    if (parts[i] > 0)
                        label1.Text += $"\n{parts[i]} купюр{ending} по {bills[i]}";

                    leftover -= parts[i] * bills[i];
                }
                int j = 0;
                for (int i = 6; i < 10; i++)
                {
                    parts[i] = leftover / coins[j];

                    if (parts[i] == 1)
                        ending = "а";
                    else if (parts[i] > 1 && parts[i] < 5)
                        ending = "ы";
                    if (parts[i] > 0)
                        label1.Text += $"\n{parts[i]} монет{ending} по {coins[j]}";

                    leftover -= parts[i] * coins[j];
                    j++;
                }
            }
        }


    }
}
